/*
 * Pasoriɥ饤
 *
 * (C)Copyright 2009, Yashiro Takeshi
 */

#ifndef _DEFINE_H_PASORI_INTERNAL_
#define _DEFINE_H_PASORI_INTERNAL_

#include <basic.h>
#include <inner.h>
#include <bstdlib.h>
#include <errcode.h>
#include <driver/driver.h>
#include <driver/rs.h>
#include <driver/usb.h>
#include <kernel/util.h>
#include <bsys/util.h>
#include <bsys/cons_io.h>
#include <bsys/cio_svc.h>
//#define DEBUG
#include <util/debug.h>

#define PASORI_VENDOR_ID       0x054c
#define PASORI_S320_PRODUCT_ID 0x01bb
/* TODO: S310, S320 */

#define PASORI_RW_DEFAULT_TMOUT 600

/*
 * 顼ɴϢ
 */
#define	EC_MASK			(0xffff0000)
#define	ED_MASK			(0x0000ffff)
#define	toERR(class,detail)	((ERR)((class) << 16 | (UH)(detail)))

/*
 * ¾
 */
#define	max(a,b)	(( (a) > (b) )? (a): (b))
#define	min(a,b)	(( (a) < (b) )? (a): (b))

/*
 * Pasoriɥ饤о
 */
typedef struct PasoriInfo_ {
  PRI      mypri;
  ID       devid;
  ID       acceptPort;

  ID       tid_norm;
  ID       tid_spec;

  int      deviceAddr;
  int      interfaceAddr;
  usbDeviceDescriptor deviceDesc;

  ID       ifid;
  ID       pipeid;

  ID       mbfid;

  W        tmout;

  FastLock lock;

  Bool     opened;
  Bool     suspended;

  DevReq*  devReq;
} PasoriInfo;

extern ERR pasoriAcceptDeviceRequest(PasoriInfo *info, UW reqptn);


#endif /* _DEFINE_H_PASORI_INTERNAL_ */
